
/* Generated by Interface Builder */

#import <appkit/View.h>
#import <appkit/Application.h>
#import <appkit/PrintInfo.h>
#import <dpsclient/wraps.h>
#import <appkit/Font.h>

#define LINEAR 0
#define LOG 1

@interface XYPlotView:View
{
    id	  plotParam;
//    id plotInspectorPanel;		
//Outlet to bring up Inspector panel with right mouse click in view
    id inspector; 
    id delegate;   
    
    float ppxunit, ppyunit;	/* pixels per xunit, pixels per y unit */

//    float xlegend[2], **ylegend;
/* for legend drawing (fixed dimension here) */
//    BOOL  drawingLegendLines;
//    NXRect legendbox;

// Instance variables added by Charlie
	char * mainTitle;
	char * xaxisLabel;
	char * yaxisLabel;	
	float xInc;
	float xMin;
	float xMax;
	float yInc;
	float yMin;
	float yMax;
	int gridState;
	int borderState;
	int autoMaxMinState;
	int autoPaperState;
	int xLinLogState;
	int yLinLogState;
	int paperSwitchRow;
	int logoFlag;

// From the file Plot.h
    NXCoord *x;			/* the x coordinates */
    NXCoord **y;		/* the y coordinates */
    int npoints;		/* number of points  */
    int ncurves;		/* number of curves  */

    NXPoint min;		/* min.x and min.y from xMin and yMin objects */
    NXPoint max;		/* max.x and max.y from xMax and yMax objects */
    NXPoint datamin;		/* xmin and ymin from the data */
    NXPoint datamax;		/* xmax and ymax from the data */
    

}   
 // methods for obtaining values from the Inspector
 -setGrid:(int)grid_state;
- setBorder:(int)border_state;
-(int)gridState;
-(int)borderState;
-setAutoMaxMinState:(int)state;
-(int)autoMaxMinState;
-setAutoPaperState:(int)state;
-(int)autoPaperState;
-setXLinLogState:(int)state;
-(int)xLinLogState;
-setYLinLogState:(int)state;
-(int)yLinLogState;
-setPaperSwitchRow:(int)state;
-(int)paperSwitchRow;
-setLogoFlag:(int)state;
-(int)logoFlag;
-setMainTitle:(const char *)mainTITLE;
-setXaxisLabel:(const char *)xAxisLabel;
-setYaxisLabel:(const char *)yAxisLabel;
-(const char *)mainTitle;
-(const char *)xaxisLabel;
-(const char *)yaxisLabel;
-setXincValue:(float)passedValue;
-setXminValue:(float)passedValue;
-setXmaxValue:(float)passedValue;
-setYincValue:(float)passedValue;
-setYminValue:(float)passedValue;
-setYmaxValue:(float)passedValue;
-(float)xIncValue;
-(float)xMinValue;
-(float)xMaxValue;
-(float)yIncValue;
-(float)yMinValue;
-(float)yMaxValue;
- rightMouseDown:(NXEvent *)theEvent;


- clear:sender;
- clearXYPlotView:sender;  // Added to clear the view from an external action
- initPlot:sender;
- setDrawColor:(float) color;
- drawLines:sender :(BOOL)xaxislog :(BOOL)yaxislog;
- drawTicMarks:(float)xmin :(float)xmax :(float)ymin :(float)ymax;
- doPrinting:sender;
- copyToPasteboard:sender;     // Copy EPS to pasteboard
//- (NXCoord *)xdata;		/* provide data for drawing the curves */
//- (NXCoord **)ydata;		/* and symbols in the legend box       */
- (int)nPoints;			/* provide no. of points to use in legend drawing */

// Any subclass of View needs to implement its own drawSelf method
- drawSelf: (const NXRect *)rects :(int)rectCount;
- initFrame:(NXRect *)frameRect;

/*
 * We implement the mouseDown method to allow zooming and also to allow
 * moving the legend box.  We lean heavily on the code in the
 * /NextDeveloper/Examples/Mandelbrot directory.
 */
//Added to plot from a stream sent by a Controller for the view
//-plotDataFromStream:(NXStream *)dataStream;
-plotDataFromStream:sender;
//- (const char *)inspectorName;	// For palette inspector
- setInspector:anObject;
-setDelegate:anObject;

// Added from version 1.7 of nxyplot:
- saveEPS:sender;
- savePSCode:(char *)aFile;

// For archiving instance variables
- read:(NXTypedStream *)stream;
- write:(NXTypedStream *)stream;

//From Plot.h:
- (NXCoord *)xdata;
- (NXCoord **)ydata;

- (int) nPoints;
- (int) nCurves;

//- (const char *) provideXtitle;
//- (const char *) provideYtitle;
//- (const char *) provideMaintitle;

- (BOOL) shouldDrawGrid;
- (BOOL) shouldDrawBox;
- (BOOL) xaxisLog;
- (BOOL) yaxisLog;
- forceXaxisLinear;
- forceYaxisLinear;

- (int)providelinestyle: (int)aCurve;
				/* 0=solid, 1=dash, 2=dot, 3=chain dash */
				/* 4=chain dot, 5=none */
- (int)providesymbolstyle: (int)aCurve;
				/* 0=none, 1=circle, 2=x, 3=up triangle */
				/* 4=down triangle, 5=diamond, 6=square  */
				/* 7=plus */

- (int)providelinethickness;    /* 0=thin, 1=medium, 2=thick */

- (int)providesymbolsize;       /* 0=pixel, 1=small, 2=medium, 3=large */

- (float) provideXmin;
- (float) provideXmax;
- (float) provideXinc;
- (float) provideYmin;
- (float) provideYmax;
- (float) provideYinc;

- resetXmin:(float)x;
- resetXmax:(float)x;
- resetXinc:(float)x;
- resetYmin:(float)x;
- resetYmax:(float)x;
- resetYinc:(float)x;

- drawPlot:sender;

- (int) readDataFromFile:(FILE *)aDataStream;
- (int) readDataFromStream:(NXStream *)aDataStream;

//Added by cwf to handle streams:
-useDataStreamAndPlot:(NXStream *)dataStream;

- findMinAndMax;

- sanityCheck;  // Taken from 1.7
- niceMinMaxInc;    // Taken from 1.7
- whyTheBeep:sender; // Taken from 1.7

- open:sender;
- openFile:(char *)dataFile;

#define N_LINE_STYLES 6		/* number of line styles (including none) */
#define N_SYMBOL_STYLES 8	/* number of symbol styles (including none) */



@end


@interface  Object(XYPlotViewDelegate)

-nxyView:sender provideDataStream:(NXStream **)dataStream;

@end