
/* Generated by Interface Builder */

#import <objc/Object.h>
#import <appkit/nextstd.h>	/* gets stdio */
#import <appkit/Form.h>		/* for NXCoord, etc. */
#import <appkit/color.h>

typedef struct _datahunk {
    char  *filename;
    float *x;
    float *ex;			/* for error bars */
    float **y;
    float **ey;			/* for error bars */
    int   npoints;
    int   ncurves;
    NXPoint datamin;
    NXPoint datamax;
    BOOL    xaxislin;
    BOOL    yaxislin;
    BOOL    has_exbars;		/* for error bars */
    BOOL    has_eybars;		/* for error bars */
} datahunk;

@interface XYPlot:Object
{
    id  datahunkArray;		/* array of datahunk structs (a Storage object) */
    id	canvas;			/* the PlotView object */

	BOOL	xAxisIsLog;
	BOOL	yAxisIsLog;
	
	int		errorBars;
	int		lineStyle;
	int		symbolStyle;
	int		cycleLineStyle;
	int		cycleSymbolStyle;
				
	
    int ncurvestotal;		/* total number of curves  */
    int nfilestotal;		/* total no. of files "open" */

    NXPoint globaldatamin;	/* xmin and ymin from the data */
    NXPoint globaldatamax;	/* xmax and ymax from the data */

    NXPoint oldMin;		/* for use by "previous view" */
    NXPoint oldMax;		/* ditto */
    NXPoint oldInc;		/* ditto */
    NXPoint currentMin;		/* ditto */
    NXPoint currentMax;		/* ditto */
    NXPoint currentInc;		/* ditto */

	float	xLimitsMin;
	float	xLimitsMax;
	float	xLimitsInc;
	float	yLimitsMin;
	float	yLimitsMax;
	float	yLimitsInc;

    int beepError;

    NXColor backgroundcolor, textcolor;
    NXColor *curvecolors;
    BOOL colorOption;

}


/* instance methods */
- init;
- initWithCanvas:aView;

- (NXCoord *)xdata:(int)n;
- (NXCoord *)exdata:(int)n;
- (NXCoord **)ydata:(int)n;
- (NXCoord **)eydata:(int)n;
- (BOOL)has_exbars:(int)n;
- (BOOL)has_eybars:(int)n;

- (int) nPoints:(int)n;
- (int) nCurves:(int)n;
- (char *) filename:(unsigned)n;
- open:sender;
- handleCompressedFile:(char *)fname;
- openFile:(char *)dataFile :(char *)realName;

- (int) nCurvesTotal;
- (int) nFiles;

- (int)providelinestyle: (int)aCurve;
				/* 0=solid, 1=dash, 2=dot, 3=chain dash */
				/* 4=chain dot, 5=none : see defs.h */
- (int)providesymbolstyle: (int)aCurve;
				/* 0=none, 1=circle, 2=x, 3=up triangle */
				/* 4=down triangle, 5=diamond, 6=square  */
				/* 7=plus : see defs.h */

- (double)provideXmin;
- (double)provideXmax;
- (double)provideXinc;
- (double)provideYmin;
- (double)provideYmax;
- (double)provideYinc;

- (float)provideGlobalXmin;
- (float)provideGlobalYmin;

- (BOOL)xAxisIsLog;
- (BOOL)yAxisIsLog;

- resetXmin:(double)x;
- resetXmax:(double)x;
- resetXinc:(double)x;
- resetYmin:(double)x;
- resetYmax:(double)x;
- resetYinc:(double)x;

- resetMinMax:sender;

- drawPlot:sender;

- (int) readData:(NXStream *)aDataStream  :(char *)fname;

- setYAxisToLinear;
- setYAxisToLog;
- setXAxisToLinear;
- setXAxisToLog;

- checkLinLog:(datahunk *)pdh;
- checkGlobalLinLog;

- findMinMax:(datahunk *)pdh;
- findGlobalMinMax;
- niceMinMaxInc;

- plotPrepAndDraw;

- removeAllFiles:sender;

- removeAndOpen:sender;

- sanityCheck;

- (NXColor) provideBackgroundColor;
- (NXColor) provideTextColor;
- (NXColor) provideCurveColor:(int)aCurve;

- setBackgroundColor:(NXColor)aColor;
- setTextColor:(NXColor)aColor;
- setCurveColor:(int)curvenum :(NXColor)aColor;
- makeCurvesColorful:(datahunk *)pdh;

- colorOn:(BOOL)onOff;

- stackOldMinMax:(float)xmin :(float)xmax :(float)ymin :(float)ymax;

- preludeToReading:(char *)fname :(datahunk **)pdh;

- postludeToReading:(char *)fname :(int)oldncurves :(datahunk *)pdh;

- previousView:sender;

@end
