
/* Generated by Interface Builder */

#import <appkit/appkit.h>
#import <dpsclient/wraps.h>

@interface XYPlotView:View
{
  id     plotParam;
  id     theFontManager;
  id     legendFont;
  id     legendTitleFont;
  id     xTitleFont;
  id     yTitleFont;
  id     mainTitleFont;
  id     ticLabelFont;
    
  float	borderBoxThickness;
  float	lineThickness;
  float	ticMarkThickness;
  float	gridThickness;
  float	frameBoxThickness;
  float	axisThickness;
  float	symbolSize;
  float errorBarBaseWidth;

  float	ppxunit, ppyunit;	/* pixels per xunit, pixels per y unit */
  float	xlegend[2], **ylegend;	/* for legend drawing (fixed dimension here) */

  int	printColor;
  int	legend;
  int	legendBox;
  int	borderBox;
  int	frameBox;
  int	gridDotted;
  int	axes;
  int	majorTicMarks,minorTicMarks;
  int	drawingLegendLines,drawingLegendSymbols;
  int	legendOpaque,opaqueBackground;
  int	handFormatXaxis,handFormatYaxis;
  int	logoFlag, paperSwitchRow, xLinLogState, yLinLogState;
  int	autoPaperState, autoMaxMinState, borderState, gridState, colorState;

  NXRect legendbox;
  NXRect xtitlebox, ytitlebox, maintitlebox;
  NXRect oldbounds;
  
  char	*xAxisTitle;
  char	*yAxisTitle;
  char	*mainTitle;
  char	*legendTitle;
  char	*curveTitle;

  int	xFormatLeft,xFormatRight,xFormatExponent;
  int	yFormatLeft,yFormatRight,yFormatExponent;

  float	xIncValue,xMinValue,xMaxValue;
  float yIncValue,yMinValue,yMaxValue;
  
}

- initFrame:(const NXRect *)frameRect;
- clear:sender;
- startPlot;
- setDrawColor:(float) color;
- drawLines:sender :(BOOL)xaxislog :(BOOL)yaxislog;
- drawSymbols:sender :(BOOL)xaxislog :(BOOL)yaxislog;
- drawErrorBars :(BOOL)xaxislog :(BOOL)yaxislog;
- drawLegend:sender;
- drawTicMarks:(float)xmin :(float)xmax :(float)ymin :(float)ymax;
- startLegend;
- doPrinting:sender;
- (NXCoord *)xdata:(int)n;	/* provide data for drawing the curves */
- (NXCoord **)ydata:(int)n;	/* and symbols in the legend box       */
- (int)nPoints:(int)n;		/* provide no. of points to use in legend drawing */
- (int)nCurves:(int)n;
- (int)nFiles;

- (BOOL)has_ebars:(int)n;

- mainTitleFont;
- xTitleFont;
- yTitleFont;
- legendFont;
- legendTitleFont;
- ticLabelFont;
/* - (NXPoint) getLegendBoxOrigin; - setLegendBoxOrigin: (NXPoint)point;
 * - (NXPoint) getXTitleBoxOrigin; - setXTitleBoxOrigin: (NXPoint)point;
 * - (NXPoint) getYTitleBoxOrigin; - setYTitleBoxOrigin: (NXPoint)point;
 * - (NXPoint) getMainTitleBoxOrigin; - setMainTitleBoxOrigin:
 * (NXPoint)point;
 */

- setMainTitleFont:aFont;
- setXTitleFont:aFont;
- setYTitleFont:aFont;
- setLegendFont:aFont;
- setLegendTitleFont:aFont;
- setTicLabelFont:aFont;

// Any subclass of View needs to implement its own drawSelf method
- drawSelf: (const NXRect *)rects :(int)rectCount;

/*
 * We implement the mouseDown method to allow zooming and also to allow
 * moving the legend box.  We lean heavily on the code in the
 * /NextDeveloper/Examples/Mandelbrot directory.
 */
- mouseDown:(NXEvent *)e;

- saveEPS:sender;

- savePSCode:(char *)aFile;

- copyPScode:sender;

- setBorder:(int)state;
- setGrid:(int)state;

- setXLinLogState:(int)state;
- setYLinLogState:(int)state;

- setAutoMaxMinState:(int)state;
- setAutoPaperState:(int)state;
- setPaperSwitchRow:(int)state;   // Set the "paper Type" to auto on switch
- setLogoFlag:(int)state;
- (int)logoFlag;

- setMainTitle:(const char *)aString;
- setXAxisTitle:(const char *)aString;
- setYAxisTitle:(const char *)aString;
- setCurveTitle:(const char *)aString;
- setLegendTitle:(const char *)aString;

- (const char *)mainTitle;
- (const char *)xAxisTitle;
- (const char *)yAxisTitle;
- (const char *)curveTitle;
- (const char *)legendTitle;

- (void)setXIncValue:(float)passedValue;
- (void)setXMinValue:(float)passedValue;
- (void)setXMaxValue:(float)passedValue;
- (void)setYIncValue:(float)passedValue;
- (void)setYMinValue:(float)passedValue;
- (void)setYMaxValue:(float)passedValue;
- (float)xIncValue;
- (float)xMinValue;
- (float)xMaxValue;
- (float)yIncValue;
- (float)yMinValue;
- (float)yMaxValue;

- (void)repositionTitles;

- plotFromStream:(NXStream *)dataStream withDescription:(const char *)name;
- plotFromStream:(NXStream *)dataStream;


@end

/* Dragging */

//extern BOOL IncludesType(const NXAtom *types, NXAtom type);

@interface XYPlotView(Drag)

- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NXDraggingInfo>)sender;

@end
