
/* Generated by Interface Builder */

#import "defs.h"
#import "title.h"
#import "XYPlotView.h"
#import "XYPlot.h"
#import "UserPath.h"
#import <appkit/appkit.h>
#import <objc/Storage.h>
#import <math.h>		/* for MAXFLOAT, etc. */
#import <strings.h>
#import <streams/streams.h>
#import <defaults/defaults.h>

#define MAX_UPATH	4096

/* The following routines are in auxil.m: */
extern void count_labels(int *, double *, double, double, double);
extern void autoformat(double, double, double, int *);
extern void handformat(float, char *, int *);

@implementation XYPlotView

- initFrame:(const NXRect *)frameRect
{
	[super initFrame:frameRect];

	colorState = NO;
	borderBoxThickness = 3.0;
	lineThickness = 0.0;
	xLinLogState = NO;
	yLinLogState = NO;
	
	theFontManager = [FontManager new];
  
	legendFont = [Font newFont:"Helvetica" size:DEFAULTFONTSIZE-3
 		           style:0 matrix:NX_IDENTITYMATRIX];
	legendTitleFont = [Font newFont:"Helvetica" size:DEFAULTFONTSIZE-2
 		           style:0 matrix:NX_IDENTITYMATRIX];
	xTitleFont = [Font newFont:"Helvetica" size:DEFAULTFONTSIZE
 		           style:0 matrix:NX_IDENTITYMATRIX];
	yTitleFont = [Font newFont:"Helvetica" size:DEFAULTFONTSIZE
 		           style:0 matrix:NX_IDENTITYMATRIX];
	mainTitleFont = [Font newFont:"Helvetica" size:DEFAULTFONTSIZE+2
 		           style:0 matrix:NX_IDENTITYMATRIX];
	ticLabelFont = [Font newFont:"Helvetica" size:DEFAULTFONTSIZE-2
 		           style:0 matrix:NX_IDENTITYMATRIX];
		
	
	[self setBorder:YES];
    [self setGrid:YES];
    [self setAutoMaxMinState:YES];
    [self setAutoPaperState:YES];
    [self setPaperSwitchRow:4];   // Set the "paper Type" to auto on switch
    [self setLogoFlag:YES];

	[self setXAxisTitle:"X Title"];
	[self setYAxisTitle:"Y Title"];
	[self setMainTitle:"Main Title"];
	[self setCurveTitle:"Curve Title"];
	[self setLegendTitle:"Legend Title"];

	[self awake];
	return self;
}

- (NXCoord *)xdata:(int)n	/* we use this in drawing the legend curves */
{
  xlegend[0] = (legendbox.origin.x + 5.33333)/ppxunit;
/* We used to have 5.0 instead of 5.33333, but that can give erroneous-looking
 * (albeit correct) results when writing to the screen: the pixels that are
 * turned on when drawing a filled circle, for example, are much different
 * when the circle's center is precisely at a pixel than when the circle's center
 * is not precisely at a pixel.  The results are much better when the center
 * of the circle is at a half-pixel point, and so that's what we do.
 */
  xlegend[1] = xlegend[0] + 40.0/ppxunit;
  /* curve fragment in legend is 40 pixels in length */
  if (!drawingLegendLines) xlegend[0] = 0.5*(xlegend[0] + xlegend[1]);
  return xlegend;
}

- (NXCoord **)ydata:(int)n	/* we use this in drawing the legend curves */
{
	int ncurves = [plotParam nCurvesTotal];
	int j;
	float yloc, yhgt;

	if(!legendFont){
		legendFont = [Font newFont:DEFAULTFONT 
					 size:DEFAULTFONTSIZE
	            	 style:0 matrix:NX_IDENTITYMATRIX];
  	}
  
	yhgt = [legendFont pointSize];
	yloc = (legendbox.origin.y - 2.0)/ppyunit;

	ylegend = (NXCoord **)realloc((void *)ylegend, ncurves*sizeof(NXCoord *));
	for (j = 0; j < ncurves; j++) {
		*(ylegend+j) = (NXCoord *)NULL; /* this is necessary */
		*(ylegend+j) = (NXCoord *)realloc((void *)*(ylegend+j), 2*sizeof(NXCoord));
		/* check for no lines and no symbols */
		if ( ([plotParam providelinestyle:j] == NOLINE)  &&
			([plotParam providesymbolstyle:j] == NOSYMBOL) ) continue;
		/* check for empty curveTitle */
		[self setCurveTitle:"Legend 1"]; //[legendForm stringValueAt:j];
		if ((drawingLegendLines || drawingLegendSymbols) && curveTitle[0]=='\0')
			continue;
		yloc = yloc + (yhgt+0.33333)/ppyunit;
		/* We used to have just yhgt (instead of yhgt+0.33333); see comments in preceding
		 * routine for the reason to change it.
		 */
  }

  for (j=0; j<ncurves; j++) {
    *(*(ylegend+j)+0) = yloc;
    *(*(ylegend+j)+1) = yloc;
    /* check for no lines and no symbols */
    if( ([plotParam providelinestyle:j] == NOLINE)  &&
       ( [plotParam providesymbolstyle:j] == NOSYMBOL) )continue;
    /* check for empty curveTitle */
    [self setCurveTitle:"Legend Title"];
    if ((drawingLegendLines || drawingLegendSymbols) && curveTitle[0]=='\0')
      continue;
    yloc -= yhgt/ppyunit;
  }
  return ylegend;
}

- (BOOL)has_ebars:(int)n
{
  return NO;
}

- (int)nPoints:(int)n
{
  if (drawingLegendLines)  return 2;
  else return 1;
}

- (int)nCurves:(int)n
{
  return [plotParam nCurvesTotal];
}

- (int)nFiles
{
  return 1;
}

- startPlot
{

  NXSetColor([plotParam provideBackgroundColor]);
  [self clear:self];
  PSsetlinewidth(NXDrawingStatus==NX_DRAWING? 0.0 : printColor?LINE_WIDTH_IF_PRINTING_COLOR:LINE_WIDTH_IF_PRINTING_BW);
  NXSetColor([plotParam provideTextColor]);


  [xTitleFont set];

  PSmoveto(xtitlebox.origin.x, xtitlebox.origin.y);
  PSshow((char *)xAxisTitle);

  [yTitleFont set];

  PSmoveto(ytitlebox.origin.x, ytitlebox.origin.y);
  PSgsave();
  PSrotate(90.0);
  PSshow((char *)yAxisTitle);
  PSgrestore();
  

  [mainTitleFont set];

  PSmoveto(maintitlebox.origin.x, maintitlebox.origin.y);
  PSshow((char *)mainTitle);

  // box around the plot:
  if (borderBox) {
    PSsetlinewidth(borderBoxThickness);  // A CHANGE!
  	NXFrameRect(&bounds);
    PSsetlinewidth(NXDrawingStatus==NX_DRAWING? 0.0: printColor ? LINE_WIDTH_IF_PRINTING_COLOR:LINE_WIDTH_IF_PRINTING_BW);
  } // A CHANGE!
  
  return self;
}

- setDrawColor:(float) color
{
  PSsetgray(color);
  return self;
}

- drawLines:sender :(BOOL)xaxislog :(BOOL)yaxislog
/*
 * This is coded so that when drawLines is called with plotParam as argument,
 * it draws the data curves; when drawLines is called with self (plotView) as
 * argument, it draws the short line segments in the legend box.
 */
{
  int i, j, jrun, n;
  NXCoord *x;
  NXCoord **y;
  UserPath *userPath = newUserPath();
  int npoints, ncurves;
  int curveindex = 0;		/* cumulative index */
  int linestyle;
  float thick = lineThickness;
  float pattern0[] = {};	/* solid      */
  float pattern1[] = {4.0, 4.0}; /* dash       */
  float pattern2[] = {1.0, 3.0}; /* dot        */
  float pattern3[] = {7.0, 3.0, 3.0, 3.0}; /* chain dash */
  float pattern4[] = {7.0, 4.0, 1.0, 4.0}; /* chain dot  */


  for (n=0; n<[sender nFiles]; n++) { /* loop over all active files */
	//beginUserPath(userPath,NO);
    x  = [sender xdata:n];
    y  = [sender ydata:n];
    ncurves = [sender nCurves:n];
    npoints = [sender nPoints:n];
    PSsetlinewidth(NXDrawingStatus==NX_DRAWING? thick :
	 printColor==0? MAX(thick, LINE_WIDTH_IF_PRINTING_BW) :
		                         MAX(thick, LINE_WIDTH_IF_PRINTING_COLOR));
    for (jrun=curveindex; jrun<curveindex+ncurves; jrun++) {
      linestyle = [plotParam providelinestyle:jrun];
      NXSetColor([plotParam provideCurveColor:jrun]);
      switch(linestyle) {
      case SOLID:
	PSsetdash(pattern0, 0, 0.0);
	break;
      case DASH:
	PSsetdash(pattern1, 2, 0.0);
	break;
      case DOT:
	PSsetdash(pattern2, 2, 0.0);
	break;
      case CHAINDASH:
	PSsetdash(pattern3, 4, 0.0);
	break;
      case CHAINDOT:
	PSsetdash(pattern4, 4, 0.0);
	break;
      case NOLINE:			/* no lines */
	continue;
      }
      if (linestyle == NOLINE) continue; /* no lines, go to next curve */
      /* If we're drawing the legend and there is no title, don't
       * bother to draw the line:
       */
      [self setCurveTitle:"Curve title"];
      if (drawingLegendLines && curveTitle[0]=='\0') continue;
      j = jrun - curveindex;	/* for indexing into the y array */
 	beginUserPath(userPath,NO);
    if (!xaxislog && !yaxislog) {
		UPmoveto(userPath,x[0]*ppxunit, *(*(y + j)) * ppyunit );
		for (i=1; i<npoints; i++) {
	  		if ( (i % MAX_UPATH) == 0 ) {
				endUserPath(userPath, dps_ustroke);
				sendUserPath(userPath);
				beginUserPath(userPath,NO);
	    		UPmoveto(userPath,x[i-1]*ppxunit, *(*(y+j)+i-1) * ppyunit);
	  		}
	  		UPlineto(userPath,x[i]*ppxunit, *(*(y+j)+i) * ppyunit);
		}
		endUserPath(userPath, dps_ustroke);
		sendUserPath(userPath);
	}
    else 
	if (!xaxislog && yaxislog) {
		PSmoveto(x[0]*ppxunit, (float)log10((double)*(*(y + j))) * ppyunit );
		for (i=1; i<npoints; i++) {
	  		if ( (i % MAX_UPATH) == 0 ) {
				endUserPath(userPath, dps_ustroke);
				sendUserPath(userPath);
				beginUserPath(userPath,NO);
	    		UPmoveto(userPath,x[i-1]*ppxunit,
					(float)log10((double)*(*(y+j)+i-1)) * ppyunit);
	  		}
	  		UPlineto(userPath,x[i]*ppxunit, 
				(float)log10((double)*(*(y+j)+i)) * ppyunit);
		}
		endUserPath(userPath, dps_ustroke);
		sendUserPath(userPath);
      }
      else 
	if (xaxislog && !yaxislog) {
		PSmoveto((float)log10((double)x[0])*ppxunit, *(*(y + j)) * ppyunit );
		for (i=1; i<npoints; i++) {
			if ( (i % MAX_UPATH) == 0 ) {
				endUserPath(userPath, dps_ustroke);
				sendUserPath(userPath);
				beginUserPath(userPath,NO);
	    		UPmoveto(userPath,(float)log10((double)x[i-1])*ppxunit,
		    		 *(*(y+j)+i-1) * ppyunit);
	  		}
	  		UPlineto(userPath,(float)log10((double)x[i])*ppxunit,
	  		 		*(*(y+j)+i) * ppyunit);
		}
		endUserPath(userPath, dps_ustroke);
		sendUserPath(userPath);
      }
    else 
	if (xaxislog && yaxislog) {
		UPmoveto(userPath,(float)log10((double)x[0])*ppxunit,
			(float)log10((double)*(*(y + j))) * ppyunit );
		for (i=1; i<npoints; i++) {
			if ( (i % MAX_UPATH) == 0 ) {
				endUserPath(userPath, dps_ustroke);
				sendUserPath(userPath);
				beginUserPath(userPath,NO);
	    		UPmoveto(userPath,(float)log10((double)x[i-1])*ppxunit,
		     		(float)log10((double)*(*(y+j)+i-1)) * ppyunit);
	  }
	  UPlineto(userPath,(float)log10((double)x[i])*ppxunit,
		   (float)log10((double)*(*(y+j)+i)) * ppyunit);
	}
		endUserPath(userPath, dps_ustroke);
		sendUserPath(userPath);
      }
    }
    curveindex += ncurves;
  }
  PSsetdash(pattern0, 0, 0.0);	/* back to solid lines  */
  return self;
}

/*
 * Our first idea for drawing the symbols was: draw each symbol just once
 * in an off-screen window, then composite them in where needed.  This worked
 * fine for screen drawing (modulo a little difficulty in compositing to just
 * the right spot), but was a miserable failure when it came to printing: the
 * print machinery scaled the composite bitmap.  We finally decided to abandon
 * compositing, in the interest of keeping our screen drawing code the same as
 * our printing code.  Should check this again under version 2.0.
 */
- drawSymbols:sender :(BOOL)xaxislog :(BOOL)yaxislog
/*
 * This is coded so that when drawSymbols is called with plotParam as argument,
 * it draws the data curves; when drawSymbols is called with self (plotView) as
 * argument, it draws the symbols in the legend box.
 */
{
/* Our current code in drawSymbols could perhaps be sped up by using wraps
 * or DPSuserpath(). See if it's too slow as it stands before trying to
 * speed it up.
 */
  int i, j, jrun, n;
  float size = 4.0;
  NXCoord *x;
  NXCoord **y;
  int npoints, ncurves;
  int curveindex = 0;
  int symbolstyle;
  register float xtmp, ytmp;

  size = symbolSize;

  PSgsave();
  for (n=0; n<[sender nFiles]; n++) { /* loop over all active files */
    x = [sender xdata:n];
    y = [sender ydata:n];
    ncurves = [sender nCurves:n];
    npoints = [sender nPoints:n];
    PSnewpath();
    PSsetlinewidth(NXDrawingStatus==NX_DRAWING? 0.0 :
                 printColor? LINE_WIDTH_IF_PRINTING_COLOR :
		                                 LINE_WIDTH_IF_PRINTING_BW);
    for (jrun=curveindex; jrun<curveindex+ncurves; jrun++) {
      symbolstyle = [plotParam providesymbolstyle:jrun];
      NXSetColor([plotParam provideCurveColor:jrun]);
      /* If we're drawing the legend and there is no title, don't
       * bother to draw the symbol:
       */
      [self setCurveTitle:"Curve title"];
      if (drawingLegendSymbols && curveTitle[0]=='\0') continue;
      j = jrun - curveindex;	/* for indexing into the y array */
      switch(symbolstyle) {
      case NOSYMBOL:
	continue;
	break;
      case CIRCLE:
	for (i=0; i<npoints; i++) {
	  /*	  circle_at(x[i], *(*(y+j)+i));      */
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  PSarc(xtmp * ppxunit, ytmp * ppyunit, size, 0.0, 360.0);
	  PSfill();
	}
	break;
      case XMARK:
	for (i=0; i<npoints; i++) {
	  /*	  x_at(x[i], *(*(y+j)+i));           */
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  PSmoveto(xtmp * ppxunit  - size, ytmp * ppyunit  - size);
	  PSrlineto(2.0*size, 2.0*size);
	  PSmoveto(xtmp * ppxunit  - size, ytmp * ppyunit  + size);
	  PSrlineto(2.0*size, -2.0*size);
	  PSstroke();
	}
	break;
      case UPTRIANGLE:
	for (i=0; i<npoints; i++) {
	  /*	  uptriangle_at(x[i], *(*(y+j)+i));    */
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  PSmoveto(xtmp * ppxunit  - size, ytmp * ppyunit  - size/SQRT3);
	  PSrlineto(2.0*size, 0.0);
	  PSrlineto(-size, size*SQRT3);
	  PSclosepath();
	  PSfill();
	}
	break;
      case DOWNTRIANGLE:
	for (i=0; i<npoints; i++) {
	  /*	  downtriangle_at(x[i], *(*(y+j)+i));     */
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  PSmoveto(xtmp * ppxunit  - size, ytmp * ppyunit  + size/SQRT3);
	  PSrlineto(2.0*size, 0.0);
	  PSrlineto(-size, -size*SQRT3);
	  PSclosepath();
	  PSfill();
	}
	break;
      case DIAMOND:
	for (i=0; i<npoints; i++) {
	  /*	  diamond_at(x[i], *(*(y+j)+i));          */
	  /* 3 pixels horizontal, 4 pixels vertical */
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  PSmoveto(xtmp * ppxunit, ytmp * ppyunit  - size);
	  PSrlineto(3.0/4.0*size, size);	
	  PSrlineto(-3.0/4.0*size, size); /* gives a pleasing diamond shape */
	  PSrlineto(-3.0/4.0*size, -size);
	  PSclosepath();
	  PSfill();
	}
	break;
      case SQUARE:
	for (i=0; i<npoints; i++) {
	  /*	  square_at(x[i], *(*(y+j)+i));            */
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  PSrectfill(xtmp * ppxunit  - size, ytmp * ppyunit  - size,
		     2.0*size, 2.0*size);
	}
	break;
      case PLUS:
	for (i=0; i<npoints; i++) {
	  /*	  plus_at(x[i], *(*(y+j)+i));              */
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  PSmoveto(xtmp * ppxunit, ytmp * ppyunit  - size);
	  PSrlineto(0.0, 2.0*size);
	  PSmoveto(xtmp * ppxunit  - size, ytmp * ppyunit);
	  PSrlineto(2.0*size, 0.0);
	  PSstroke();
	}
	break;
      }
    }
    curveindex += ncurves;
  }
  PSgrestore();

  return self;
}

- drawErrorBars :(BOOL)xaxislog :(BOOL)yaxislog
{
  int     n, j, npoints, ncurves, jrun, i;
  NXCoord *x, *ex = NULL;	/* ex and ey initialized to avoid */
  NXCoord **y, **ey = NULL;	/* compiler warning               */
  int     curveindex = 0;
  register float xtmp, ytmp, tmp1, tmp2;
  float   width = errorBarBaseWidth;
  BOOL    exbars, eybars;

  PSgsave();
  for (n=0; n<[plotParam nFiles]; n++) { /* loop over all active files */
    exbars = [plotParam has_exbars:n];
    eybars = [plotParam has_eybars:n];
    ncurves = [plotParam nCurves:n];
    if (!exbars  && !eybars ) {       /* skip if no error bars */
      curveindex += ncurves;	      /* but have to bump this index, */
      continue;			      /* to get the colors correct    */
    }
    x = [plotParam xdata:n];	/* we have to draw error bars */
    if (exbars) {
      ex = [plotParam exdata:n];
    }
    y = [plotParam ydata:n];
    if (eybars) {
      ey = [plotParam eydata:n];
    }
    npoints = [plotParam nPoints:n];
    PSnewpath();
    PSsetlinewidth(NXDrawingStatus==NX_DRAWING? 0.0 :
		 printColor? LINE_WIDTH_IF_PRINTING_COLOR :
		                                 LINE_WIDTH_IF_PRINTING_BW);
    for (jrun=curveindex; jrun<curveindex+ncurves; jrun++) {
      NXSetColor([plotParam provideCurveColor:jrun]);
      j = jrun - curveindex;	/* for indexing into the y and ey arrays */
      /* check if error bars are desired */
      if (exbars) {
	for (i=0; i<npoints; i++) {
	  ytmp = (yaxislog? (float)log10((double)*(*(y+j)+i)) : *(*(y+j)+i));
	  if (xaxislog) {
	    if (x[i] - ex[i] <= 0.0) { /* avoid log of negative */
	      tmp1 = (float)log10( (double) x[i] ); /* what to do? */
	    }
	    else {
	      tmp1 = (float)log10( (double) (x[i] - ex[i]) );
	    }
	    if (x[i] + ex[i] <= 0.0) { /* again avoid log of negative */
	      tmp2 = (float)log10( (double) x[i] );
	    }
	    else {
	      tmp2 = (float)log10( (double) (x[i] + ex[i]) );
	    }
	  }
	  else {
	    tmp1 = x[i] - ex[i];
	    tmp2 = x[i] + ex[i];
	  }
	  PSmoveto(tmp1 * ppxunit, ytmp * ppyunit);
	  PSrlineto((tmp2-tmp1)*ppxunit, 0.0);
	  if (width > 0.0) {
	    PSmoveto(tmp1 * ppxunit, ytmp*ppyunit - width/2.0);
	    PSrlineto(0.0, width);
	    PSmoveto(tmp2 * ppxunit, ytmp*ppyunit - width/2.0);
	    PSrlineto(0.0, width);
	  }
	  PSstroke();
	}
      }
      if (eybars) {
	for (i=0; i<npoints; i++) {
	  xtmp = (xaxislog? (float)log10((double)x[i]) : x[i]);
	  if (yaxislog) {
	    if ((*(*(y+j)+i) - *(*(ey+j)+i)) <= 0.0) { /* avoid log of negative */
	      tmp1 = (float)log10( (double) (*(*(y+j)+i)) );
	    }
	    else {
	      tmp1 = (float)log10( (double) (*(*(y+j)+i) - *(*(ey+j)+i)) );
	    }
	    if ((*(*(y+j)+i) + *(*(ey+j)+i)) <= 0.0) { /* avoid log of negative */
	      tmp2 = (float)log10( (double) (*(*(y+j)+i)) );
	    }
	    else {
	      tmp2 = (float)log10( (double) (*(*(y+j)+i) + *(*(ey+j)+i)) );
	    }
	  }
	  else {
	    tmp1 = *(*(y+j)+i) - *(*(ey+j)+i);
	    tmp2 = *(*(y+j)+i) + *(*(ey+j)+i);
	  }
	  PSmoveto(xtmp * ppxunit, tmp1 * ppyunit);
	  PSrlineto(0.0, (tmp2-tmp1)*ppyunit);
	  if (width > 0.0) {
	    PSmoveto(xtmp*ppxunit - width/2.0, tmp1 * ppyunit);
	    PSrlineto(width, 0.0);
	    PSmoveto(xtmp*ppxunit - width/2.0, tmp2 * ppyunit);
	    PSrlineto(width, 0.0);
	  }
	  PSstroke();
	}
      }
    }
    curveindex += ncurves;
  }
  PSgrestore();

  return self;
}


- startLegend
{
	int j;
	int ncurves = [plotParam nCurvesTotal];
	float maxcurvetitlewid = 0;
	float yhgt;

	if (!legendFont) {
		legendFont = [Font newFont:DEFAULTFONT 
		           size:DEFAULTFONTSIZE
		           style:0
		           matrix:NX_IDENTITYMATRIX];
	}
	yhgt = [legendFont pointSize];	/* height of text */

  [legendFont set];

  legendbox.size.height = 10.0;

	for (j=0; j<ncurves; j++) {
		/* check for no lines and no symbols */
		if( ([plotParam providelinestyle:j] == NOLINE)  &&
		( [plotParam providesymbolstyle:j] == NOSYMBOL) )continue;
		[self setCurveTitle:"Curve Title"];
		/* skip this curve if there is no title: */
		if ([legendFont getWidthOf:curveTitle] == 0.0) continue;
			maxcurvetitlewid = MAX(maxcurvetitlewid,
			   [legendFont getWidthOf:curveTitle]);
		legendbox.size.height += yhgt; /* increment by yhgt for every curve */
	}

	/* check on legend title width also */

	if (!legendTitleFont) {
		legendTitleFont = [Font newFont:DEFAULTFONT 
		            size:DEFAULTFONTSIZE
		            style:0
		            matrix:NX_IDENTITYMATRIX];
	}
	yhgt = [legendTitleFont pointSize];	/* height of text */

  [legendTitleFont set];
  maxcurvetitlewid = MAX(maxcurvetitlewid,
			   [legendTitleFont getWidthOf:legendTitle]);

  legendbox.size.width = 5.0 + 40.0 + 5.0 + maxcurvetitlewid + 5.0;
  /* legendboxwidth = L. margin + 40 + space + curve title + R. margin */
  if([legendTitleFont getWidthOf:legendTitle] != 0)
    legendbox.size.height = legendbox.size.height + 2.0*yhgt - 4.0;
  return self;
}

- drawLegend:sender
{
	int j;
	int ncurves = [plotParam nCurvesTotal];
	float yhgt;

	/* get legend text font initialized */
	if (!legendFont) {
		legendFont = [Font newFont:DEFAULTFONT 
		           size:DEFAULTFONTSIZE
		           style:0
		           matrix:NX_IDENTITYMATRIX];
	}
	yhgt = [legendFont pointSize];

	[legendFont set];

	drawingLegendLines = YES;
	[self xdata:0];
	[self ydata:0];

	NXSetColor([plotParam provideBackgroundColor]);

	if (legendOpaque == NO) {
		NXRectFill(&legendbox);
	}

	[sender drawLines:sender :NO :NO];	/* legend lines, linear axes always */

	NXSetColor([plotParam provideTextColor]);

	for (j=0; j<ncurves; j++) {
		/* check for no lines and no symbols */
		if ( ([plotParam providelinestyle:j] == NOLINE)  &&
		([plotParam providesymbolstyle:j] == NOSYMBOL) ) continue;
		[self setCurveTitle:"Legend Text"];
		/* skip this curve if there is no title: */
		if ([legendFont getWidthOf:curveTitle] == 0.0) continue;
		PSmoveto(xlegend[1]*ppxunit + 5.0, 
		*(*(ylegend+j)+0) * ppyunit - 0.33*yhgt);
		PSshow((char *)curveTitle);
	}


	if (!legendTitleFont) {
		legendTitleFont = [Font newFont:DEFAULTFONT 
		            size:DEFAULTFONTSIZE
		            style:0
		            matrix:NX_IDENTITYMATRIX];
	}
	yhgt = [legendTitleFont pointSize];	/* height of text */

	[legendTitleFont set];
	PSmoveto(xlegend[0]*ppxunit - 5.0 + legendbox.size.width/2.0
		- 0.5*[legendTitleFont getWidthOf:legendTitle],
	   *(*(ylegend+0)+0) * ppyunit + yhgt);
	PSshow((char *)legendTitle);
	if(legendBox) {
	PSsetlinewidth(NXDrawingStatus==NX_DRAWING? 0.0 :
		 printColor? LINE_WIDTH_IF_PRINTING_COLOR :
		                                 LINE_WIDTH_IF_PRINTING_BW);
    PSrectstroke(legendbox.origin.x, legendbox.origin.y,
		 legendbox.size.width, legendbox.size.height);
	}
	drawingLegendLines = NO;
	drawingLegendSymbols = YES;
	[sender drawSymbols:sender :NO :NO];	/* legend symbols, linear axes always */
	drawingLegendSymbols = NO;

	return self;
}

- clear:sender
{
  /*
   * Derek Lisoski (dlisoski@cco.caltech.edu) suggests not drawing the
   * opaque background rectangle when you print or save a file.  Then
   * when you read the saved plots into a separate drawing program you
   * can overlay multiple plots or get the plots arbitrarily close to
   * each other.  There may be some problems with background colors
   * when importing into various applications (Create or Draw, e.g.)
   */
  if (NXDrawingStatus == NX_DRAWING || opaqueBackground == NO) {
    NXRectFill(&bounds);
  /* for color; had NXEraseRect, but that always fills with white    */
  }
  return self;
}

/*
 * This routine assumes it is called with xmin != xmax and ymin != ymax.
 * Bad things may happen if this is not the case.
 * The input parameters are assumed to be in pixel coordinates.
 */
- drawTicMarks:(float)xmin :(float)xmax :(float)ymin :(float)ymax
{
  float pattern0[] = {};	/* solid      */
  float pattern2[] = {1.0, 3.0}; /* dot        */
  double xinc_unscaled = [plotParam provideXinc];
  double yinc_unscaled = [plotParam provideYinc];
  double xmin_unscaled = [plotParam provideXmin];
  double ymin_unscaled = [plotParam provideYmin];
  double xmax_unscaled = [plotParam provideXmax];
  double ymax_unscaled = [plotParam provideYmax];
  /* It is useful in some fairly extreme cases to have the increments
   * not in pixel coordinates (otherwise can get "bad" labels).
   */
  char ticlabel[32];
  id smallTicLabelFont;
  float x, y, ticloc_rat, xticloc, yticloc;
  BOOL xAxisIsLog = [plotParam xAxisIsLog];
  BOOL yAxisIsLog = [plotParam yAxisIsLog];
  int  ticLocation;		/* 0=axes, 1=2 sides, 2=4 sides */
  float  ticmarklen = .5;
  int    nmin, ninc, nmax, j, i;
  float  ticloc, xwid, labelHgt, smallLabelHgt;
  double first;
  int    nlabels;
  int    axformat[3];


	NXSetColor([plotParam provideTextColor]);

	ticLocation = 2;


 	if(!ticLabelFont)ticLabelFont = 
					[Font newFont:DEFAULTFONT 
					 size:DEFAULTFONTSIZE
	            	 style:0 matrix:NX_IDENTITYMATRIX];
				
    labelHgt = [ticLabelFont pointSize];

    smallLabelHgt = (labelHgt >= 10.0? labelHgt - 2.0 : 8.0);
    smallTicLabelFont = [Font newFont:[ticLabelFont name] 
	             size:smallLabelHgt
	             style:[ticLabelFont style]
	             matrix:NX_IDENTITYMATRIX];

  /* get tic font initialized */
  [ticLabelFont set];

  PSnewpath();
  //PSsetlinewidth([ticMarkThicknessText floatValue]);
  PSsetlinewidth(ticMarkThickness);
  if (xAxisIsLog) {		/* x-axis is logarithmic */
    nmin = (int)floor((double)(xmin/ppxunit));
    nmax = (int)ceil((double)(xmax/ppxunit));
    ninc = (int)rint(log10(xinc_unscaled));
    if (ninc == 0) ninc = 1;	/* avoid infinite loop */
    if (handFormatXaxis) {
 		axformat[0] = xFormatLeft;
		axformat[1] = xFormatRight;
		axformat[2] = xFormatExponent;
    }
    for (j=nmin; j<=nmax; j+=ninc) {
      if ( (float)j * ppxunit >= xmin &&  (float)j * ppxunit <= xmax ) {
	if (gridState) {
	  PSsetlinewidth(gridThickness);
	  PSmoveto((float)j * ppxunit, ymin);
	  if (gridDotted)
	    PSsetdash(pattern2, 2, 0.0);
	  else
	    PSsetdash(pattern0, 0, 0.0);
	  PSrlineto(0.0, ABS(ymax-ymin));
	  PSstroke();
	  PSsetlinewidth(ticMarkThickness);
	}
	PSmoveto((float)j * ppxunit, ymin - ticmarklen*6.0); /* big tic mark */
	PSsetdash(pattern0, 0, 0.0);
	PSrlineto(0.0, ticmarklen*6.0);
	PSstroke();
	if (ticLocation == 2) {	/* tics on right and top */
	  PSmoveto((float)j * ppxunit, ymax); /* big tic mark */
	  PSsetdash(pattern0, 0, 0.0);
	  PSrlineto(0.0, ticmarklen*6.0);
	  PSstroke();
	}
	if (!handFormatXaxis) {
	  ticloc_rat = labelHgt/DEFAULTFONTSIZE;
	  PSmoveto((float)j * ppxunit - ticloc_rat*8.0,
		   ymin - MAX(24.0*ticloc_rat,
			      24.0*ticloc_rat*(ticmarklen+10.0)/10.0));
	  PSshow("10");
	  [smallTicLabelFont set];
	  PSmoveto((float)j * ppxunit + ticloc_rat*4.0,
		   ymin - MAX(16.0*ticloc_rat,
			       8.0*ticloc_rat*(2.0 + 0.3*ticmarklen)));
	  sprintf(ticlabel, "%-5d", j);
	  PSshow(ticlabel);
	  [ticLabelFont set];
	}
	else {
	  x = (float) pow((double)10.0, (double)j);
	  handformat(x, ticlabel, axformat);
	  xwid = [ticLabelFont getWidthOf:ticlabel];
	  PSmoveto((float)j * ppxunit - xwid/2.0,
		    ymin - labelHgt - MAX(5.0, 5.0*ticmarklen));
	  PSshow(ticlabel);
	}
      }
      if (minorTicMarks) {
	for (i=2; i<=9; i++) {
	  ticloc = (float)j * ppxunit + ppxunit*(float)log10((double)i);
	  if ( ticloc>xmin && ticloc<xmax ) {
	    PSmoveto(ticloc, ymin - ticmarklen*3.0); /* small tic mark */
	    PSrlineto(0.0, ticmarklen*3.0);
	    PSstroke();
	    if (ticLocation == 2) { /* tics on right and top */
	      PSmoveto(ticloc, ymax); /* small tic mark */
	      PSrlineto(0.0, ticmarklen*3.0);
	      PSstroke();
	    }
	  }
	}
      }
    }
  }
  else {			/* x-axis is linear */
    yticloc = (ticLocation > 0 ? ymin : 2.0*ticmarklen) ;
    /* If inc is big, skip tic marks entirely */
    if (fabs(xinc_unscaled) < fabs(xmax_unscaled - xmin_unscaled)) {
      count_labels(&nlabels, &first, xmin_unscaled, xinc_unscaled, xmax_unscaled);
      if (handFormatXaxis) {
		axformat[0] = xFormatLeft;
		axformat[1] = xFormatRight;
		axformat[2] = xFormatExponent;
      }
      else {
	autoformat(xmin_unscaled, xinc_unscaled, xmax_unscaled, axformat);
		xFormatLeft  = axformat[0];
		xFormatRight = axformat[1];
		xFormatExponent = axformat[2];
      }
      /*
       * next loop starts at -1 because there may be room for minor tic
       * marks to the left of the first major tic mark (after a zoom, e.g.)
       */
      for (i = -1; i < nlabels; i++) {
	/* Special test here for what should be exact 0 (but isn't sometimes
	 * due to floating-point arithmetic.
	 */
	if (fabs(first/xinc_unscaled + (float)i) < 4.0e-7) { /* ugly */
	  x = 0.0;
	}
	else {
	  x = (first + (xinc_unscaled)*(float)i) * ppxunit;
	}
	if (x >= xmin) {	/* ensure major tic mark won't be off edge */
	  if (gridState) {
	    PSsetlinewidth(gridThickness);
	    PSmoveto(x, ymin);
	    if (gridDotted)
	      PSsetdash(pattern2, 2, 0.0);
	    else
	      PSsetdash(pattern0, 0, 0.0);
	    PSrlineto(0.0, ABS(ymax-ymin));
	    PSstroke();
	    PSsetlinewidth(ticMarkThickness);
	  }
	  /* Nothing at 0 if we're putting tic marks on axes:  */
	  if (ticLocation > 0 || x != 0.0) {
	    PSmoveto(x, yticloc - ticmarklen*4.0);
	    PSsetdash(pattern0, 0, 0.0);
	    PSrlineto(0.0, ticmarklen*4.0);
	    PSstroke();
            if (ticLocation == 2) { /* tics on right and top */
	      PSmoveto(x, ymax);
	      PSsetdash(pattern0, 0, 0.0);
	      PSrlineto(0.0, ticmarklen*4.0);
	      PSstroke();
            }
	    handformat(x/ppxunit, ticlabel, axformat);
	    xwid = [ticLabelFont getWidthOf:ticlabel];
	    PSmoveto(x - xwid/2.0, yticloc - labelHgt - MAX(5.0, 5.0*ticmarklen));
	    PSshow(ticlabel);
	  }
	}
	if (minorTicMarks) {
          if (ticLocation > 0) { /* tic marks on frame */
	    for (j=1; j<=9; j++) {
	      ticloc = x + ((xinc_unscaled/10.0)*(float)j)*ppxunit;
	      if (ticloc>xmin && ticloc<xmax) {
	        PSmoveto(ticloc, yticloc - ticmarklen*2.0);
	        PSrlineto(0.0, ticmarklen*2.0);
	        PSstroke();
                if (ticLocation == 2) {	/* tics on right and top */
  	          PSmoveto(ticloc, ymax);
	          PSrlineto(0.0, ticmarklen*2.0);
	          PSstroke();
                }
              }
            }
          }
          else {
	    for (j=1; j<=9; j++) {
	      ticloc = x + ((xinc_unscaled/10.0)*(float)j)*ppxunit;
	      if (ticloc>xmin && ticloc<xmax) {
	        PSmoveto(ticloc, -ticmarklen);
	        PSrlineto(0.0, 2.0*ticmarklen);
	        PSstroke();
              }
            }
          }
	}
      }
    }
  }
  if (yAxisIsLog) {		/* y-axis is logarithmic */
    nmin = (int)floor((double)(ymin/ppyunit));
    nmax = (int)ceil((double)(ymax/ppyunit));
    ninc = (int)rint(log10(yinc_unscaled));
    if (ninc == 0) ninc = 1;	/* avoid infinite loop */
    if (handFormatYaxis) {
      axformat[0] = yFormatLeft;
      axformat[1] = yFormatRight;
      axformat[2] = yFormatExponent;
    }
    for (j=nmin; j<=nmax; j+=ninc) {
      if ( (float)j * ppyunit >= ymin &&  (float)j * ppyunit <= ymax ) {
	if (gridState) {
	  PSsetlinewidth(gridThickness);
	  PSmoveto(xmin, (float)j * ppyunit);
	  if (gridDotted)
	    PSsetdash(pattern2, 2, 0.0);
	  else
	    PSsetdash(pattern0, 0, 0.0);
	  PSrlineto(ABS(xmax-xmin), 0.0);
	  PSstroke();
	  PSsetlinewidth(ticMarkThickness);
	}
	PSmoveto(xmin - ticmarklen*6.0, (float)j * ppyunit); /* big tic mark */
	PSsetdash(pattern0, 0, 0.0);
	PSrlineto(ticmarklen*6.0, 0.0);
	PSstroke();
        if (ticLocation == 2) {	/* tics on right and top */
	  PSmoveto(xmax, (float)j * ppyunit); /* big tic mark */
	  PSsetdash(pattern0, 0, 0.0);
	  PSrlineto(ticmarklen*6.0, 0.0);
	  PSstroke();
        }
	if (!handFormatYaxis) {
	  ticloc_rat = labelHgt/DEFAULTFONTSIZE;
	  PSmoveto(xmin - MAX(40.0*ticloc_rat,
			      40.0*ticloc_rat*(ticmarklen+10.0)/10.0),
		   (float)j * ppyunit - ticloc_rat*7.0);
	  PSshow("10");
	  [smallTicLabelFont set];
	  PSmoveto(xmin - MAX(24.0*ticloc_rat,
			       4.0*ticloc_rat*(ticmarklen + 6.0)),
		   (float)j * ppyunit - ticloc_rat*1.0);
	  sprintf(ticlabel, "%-5d", j);
	  PSshow(ticlabel);
	  [ticLabelFont set];
	}
	else {
	  y = (float) pow((double)10.0, (double)j);
	  handformat(y, ticlabel, axformat);
	  xwid = [ticLabelFont getWidthOf:ticlabel];
	  PSmoveto(xmin - xwid - MAX(10.0, 5.0*ticmarklen),
		       (float)j * ppyunit + 2.0 - labelHgt/2.0);
	  PSshow(ticlabel);
	}
      }
      if (minorTicMarks) {
	for (i=2; i<=9; i++) {
	  ticloc = (float)j * ppyunit + ppyunit*(float)log10((double)i);
	  if (ticloc>ymin && ticloc<ymax) {
	    PSmoveto(xmin - ticmarklen*3.0, ticloc); /* small tic mark */
	    PSrlineto(ticmarklen*3.0, 0.0);
	    PSstroke();
            if (ticLocation == 2) { /* tics on right and top */
	      PSmoveto(xmax, ticloc); /* small tic mark */
	      PSrlineto(ticmarklen*3.0, 0.0);
	      PSstroke();
            }
	  }
	}
      }
    }
  }
  else {			/* y-axis is linear */
    xticloc = (ticLocation > 0 ? xmin : 2.0*ticmarklen) ;
    /* If inc is big, skip tic marks entirely */
    if (fabs(yinc_unscaled) < fabs(ymax_unscaled - ymin_unscaled)) {
      count_labels(&nlabels, &first, ymin_unscaled, yinc_unscaled, ymax_unscaled);
      if (handFormatYaxis) {
		axformat[0] = yFormatLeft;
		axformat[1] = yFormatRight;
		axformat[2] = yFormatExponent;
      }
      else {
	autoformat(ymin_unscaled, yinc_unscaled, ymax_unscaled, axformat);
		yFormatLeft = axformat[0];
		yFormatRight = axformat[1];
		yFormatExponent = axformat[2];
      }
      /*
       * next loop starts at -1 because there may be room for minor tic
       * marks to the left of the first major tic mark (after a zoom, e.g.)
       */
      for (i = -1; i < nlabels; i++) {
	/* Special test here for what should be exact 0 (but isn't sometimes
	 * due to floating-point arithmetic.
	 */
	if (fabs(first/yinc_unscaled + (float)i) < 4.0e-7) { /* ugly */
	  y = 0.0;
	}
	else {
	  y = (first + (yinc_unscaled)*(float)i) * ppyunit;
	}
	if (y >= ymin) {	/* ensure major tic mark won't be off edge */
	  if (gridState) {
	    PSsetlinewidth(gridThickness);
	    PSmoveto(xmin, y);
	    if (gridDotted)
	      PSsetdash(pattern2, 2, 0.0);
	    else
	      PSsetdash(pattern0, 0, 0.0);
	    PSrlineto(ABS(xmax-xmin), 0.0);
	    PSstroke();
	    PSsetlinewidth(ticMarkThickness);
	  }
	  /* Nothing at 0 if we're putting tic marks on axes:  */
	  if (ticLocation > 0 || y != 0.0) {
	    PSmoveto(xticloc - ticmarklen*4.0, y);
	    PSsetdash(pattern0, 0, 0.0);
	    PSrlineto(ticmarklen*4.0, 0.0);
	    PSstroke();
            if (ticLocation == 2) { /* tics on right and top */
              PSmoveto(xmax, y);
	      PSsetdash(pattern0, 0, 0.0);
	      PSrlineto(ticmarklen*4.0, 0.0);
	      PSstroke();
            }
	    handformat(y/ppyunit, ticlabel, axformat);
	    xwid = [ticLabelFont getWidthOf:ticlabel];
	    PSmoveto(xticloc - xwid - MAX(10.0, 5.0*ticmarklen),
		     y + 2.0 - labelHgt/2.0);
	    PSshow(ticlabel);
	  }
	}
	if (minorTicMarks) {
          if (ticLocation > 0) { /* tics on frame */
	    for (j=1; j<=9; j++) {
	      ticloc = y + ((yinc_unscaled/10.0)*(float)j)*ppyunit;
	      if (ticloc>ymin && ticloc<ymax) {
	        PSmoveto(xticloc - ticmarklen*2.0, ticloc);
	        PSrlineto(ticmarklen*2.0, 0.0);
	        PSstroke();
                if (ticLocation == 2) {	/* tics on right and top */
	          PSmoveto(xmax, ticloc);
	          PSrlineto(ticmarklen*2.0, 0.0);
	          PSstroke();
                }
              }
	    }
	  }
          else {
            for (j=1; j<=9; j++) {
	      ticloc = y + ((yinc_unscaled/10.0)*(float)j)*ppyunit;
	      if (ticloc>ymin && ticloc<ymax) {
	        PSmoveto(-ticmarklen, ticloc);
	        PSrlineto(2.0*ticmarklen, 0.0);
	        PSstroke();
              }
	    }
	  }
	}
      }
    }
  }
  return self;
}

- drawSelf: (const NXRect *)rects :(int)rectCount
{
  BOOL xAxisIsLog = [plotParam xAxisIsLog];
  BOOL yAxisIsLog = [plotParam yAxisIsLog];
  float xscale,yscale;
  NXRect framerect;

	float  xmin = (float)[plotParam provideXmin];
	float  xmax = (float)[plotParam provideXmax];
	float  ymin = (float)[plotParam provideYmin];
	float  ymax = (float)[plotParam provideYmax];

	[self startPlot];


	if(strcmp([NXApp appName] , "InterfaceBuilder") ==0 && [self logoFlag] == YES){
	[self getFrame:&framerect];

	xscale = framerect.size.width/500.0;
	yscale = framerect.size.height/300.0;
	
			PSWTestTitle(xscale, yscale);
	}

  if ([plotParam nFiles] == 0) return self; /* no data */

  if (xmin==xmax || ymin==ymax) return self; /* avoid division by zero */

  PSgsave();

  PSsetmiterlimit(1);		// suggested by Carrick Talmadge
                                // (clt@eotvos.physics.purdue.edu)

  PStranslate(XOFFSET, YOFFSET);

  if (xAxisIsLog) {	/* x-axis is logarithmic */
    ppxunit = 0.9*(bounds.size.width-XOFFSET)
      /(float)log10((double)(xmax/xmin));
    xmin = (float)log10((double)xmin) * ppxunit;
    xmax = (float)log10((double)xmax) * ppxunit;
  }
  else {			/* x-axis is linear */
    ppxunit = 0.9*(bounds.size.width-XOFFSET)/(xmax-xmin);
    xmin = xmin*ppxunit;	/* drawing is all in pixel coordinates */
    xmax = xmax*ppxunit;
  }
  if (yAxisIsLog) {	/* y-axis is logarithmic */
    ppyunit = 0.9*(bounds.size.height-YOFFSET*1.5)
      /(float)log10((double)(ymax/ymin));
    ymin = (float)log10((double)ymin) * ppyunit;
    ymax = (float)log10((double)ymax) * ppyunit;
  }
  else {			/* y-axis is linear */
    ppyunit = 0.9*(bounds.size.height-YOFFSET*1.5)/(ymax-ymin);
    ymin = ymin*ppyunit;
    ymax = ymax*ppyunit;
  }
  PStranslate(-xmin, -ymin);
  // inner "frame" box
  if (frameBox) {
    PSsetlinewidth(frameBoxThickness);
    PSnewpath();
    PSmoveto(xmin, ymin);
    PSlineto(xmax, ymin);
    PSlineto(xmax, ymax);
    PSlineto(xmin, ymax);
    PSclosepath();
    PSstroke();
 /* reset line width */
    PSsetlinewidth(NXDrawingStatus==NX_DRAWING? 0.0 :
		 printColor? LINE_WIDTH_IF_PRINTING_COLOR :
		                                 LINE_WIDTH_IF_PRINTING_BW);
  }

  if (axes) {
    PSnewpath();
    PSsetlinewidth(axisThickness);
    PSmoveto(0.0, ymin);
    PSlineto(0.0, ymax);
    PSstroke();
    PSmoveto(xmin, 0.0);
    PSlineto(xmax, 0.0);
    PSstroke();
  }

  if (majorTicMarks)
    [self drawTicMarks:xmin :xmax :ymin :ymax]; /* do this before clipping */

  /* MIN and MAX below in case xmin > xmax  and/or  ymin > ymax. */
  PSrectclip(MIN(xmin,xmax), MIN(ymin,ymax), ABS(xmax-xmin), ABS(ymax-ymin));

  [self drawLines:plotParam :xAxisIsLog :yAxisIsLog];
  [self drawSymbols:plotParam :xAxisIsLog :yAxisIsLog];

  [self drawErrorBars :xAxisIsLog :yAxisIsLog];

  PSgrestore();
  if (legend) {
    [self startLegend];
    [self drawLegend:self];
  }

  return self;
}

- doPrinting:sender
{

  id myPrintPanel = [PrintPanel new];

  [ [NXApp printInfo] setMarginLeft:72.0 right:72.0 top:72.0 bottom:72.0 ];

  if (bounds.size.height > bounds.size.width) { /* portrait mode */
    if (bounds.size.height/bounds.size.width > 9.0/6.5) {
      [ [NXApp printInfo] setScalingFactor: 9.0*72.0/bounds.size.height];
    }
    else {
      [ [NXApp printInfo] setScalingFactor: 6.5*72.0/bounds.size.width];
    }
    [ [NXApp printInfo] setOrientation:NX_PORTRAIT andAdjust:YES ];
  }
  else {			/* landscape mode */
    if (bounds.size.width/bounds.size.height > 9.0/6.5) {
      [ [NXApp printInfo] setScalingFactor: 9.0*72.0/bounds.size.width];
    }
    else {
      [ [NXApp printInfo] setScalingFactor: 6.5*72.0/bounds.size.height];
    }
    [ [NXApp printInfo] setOrientation:NX_LANDSCAPE andAdjust:YES ];
  }

  [myPrintPanel setAccessoryView:nil];

  [self printPSCode:sender];
  return self;
}

- mouseDown:(NXEvent *)e
/*
 * This code taken from the Mandelbrot example in /NextDeveloper (and modified).
 * We implement the mouseDown method so the user can sweep out a section of
 * the view and select that as the current window in which to view the curve(s).
 */
{
  int looping = YES;
  int oldMask;
  NXRect bbox;
  NXPoint startPoint, currPoint;
  float xmin, xmax, ymin, ymax;
  register float t1, t2, t3, t4;
  int  zooming;
  BOOL xAxisIsLog = [plotParam xAxisIsLog];
  BOOL yAxisIsLog = [plotParam yAxisIsLog];
  
  zooming = ZOOM;
//  if (strncmp([zoomChoice title], "Zoom/Move", 9) == 0)
//    zooming = NOZOOM;
//  else if (strncmp([zoomChoice title], "Move legend", 11) == 0)
//    zooming = MOVELEGEND;
//  else if (strncmp([zoomChoice title], "Move x title", 12) == 0)
//    zooming = MOVEXTITLE;
//  else if (strncmp([zoomChoice title], "Move y title", 12) == 0)
//    zooming = MOVEYTITLE;
//  else if (strncmp([zoomChoice title], "Move main title", 15) == 0)
//    zooming = MOVEMAINTITLE;

  if (zooming == ZOOM) {	/* really zooming */
    if (xAxisIsLog) {
      xmin = (float)log10([plotParam provideXmin]) * ppxunit;
      xmax = (float)log10([plotParam provideXmax]) * ppxunit;
    }
    else {
      xmin = [plotParam provideXmin] * ppxunit;
      xmax = [plotParam provideXmax] * ppxunit;
    }
    if (yAxisIsLog) {
      ymin = (float)log10([plotParam provideYmin]) * ppyunit;
      ymax = (float)log10([plotParam provideYmax]) * ppyunit;
    }
    else {
      ymin = [plotParam provideYmin] * ppyunit;
      ymax = [plotParam provideYmax] * ppyunit;
    }
  
    oldMask =  [window addToEventMask:NX_MOUSEDRAGGEDMASK];
    startPoint = e->location;
    [self convertPoint:&startPoint fromView:nil];
    NXSetRect(&bbox,startPoint.x,startPoint.y,0.0,0.0);
    [self lockFocus];
    while (looping) {
      e=[NXApp getNextEvent:NX_MOUSEUPMASK | NX_MOUSEDRAGGEDMASK];
      currPoint = e->location;
      [self convertPoint:&currPoint fromView:nil];
      bbox.size.width = (currPoint.x - startPoint.x);
      bbox.size.height = (currPoint.y - startPoint.y);
      /* Normalize bbox to always have positive width and height */
      if (bbox.size.width < 0) {
	bbox.size.width = -bbox.size.width;
	bbox.origin.x   = startPoint.x - bbox.size.width;
      }
      if (bbox.size.height < 0) {
	bbox.size.height = -bbox.size.height;
	bbox.origin.y    = startPoint.y - bbox.size.height;
      }

      PSnewinstance();
      if ((looping = (e->type == NX_MOUSEDRAGGED))) {
	PSsetinstance(YES);
	NXSetColor([plotParam provideTextColor]);
	NXFrameRect(&bbox);
	PSsetinstance(NO);
      }
    }
    [self unlockFocus];
    [window setEventMask:oldMask];
    if ((bbox.size.width > 0) && (bbox.size.height > 0)) {
      /* At this point, bbox is in window coordinates.  Convert to curve
       * coordinates based on this view's coordinates and the bounding box.
       */

      xmin = xmin + (bbox.origin.x - XOFFSET);
      xmax = xmin + bbox.size.width;
      ymin = ymin + (bbox.origin.y - YOFFSET);
      ymax = ymin + bbox.size.height;

      /* save old min/max -- must adjust if log axis */
      t1 = xmin/ppxunit;
      t2 = xmax/ppxunit;
      t3 = ymin/ppyunit;
      t4 = ymax/ppyunit;
      if (xAxisIsLog) {
	t1 = (float) pow((double)10.0, (double)t1);
	t2 = (float) pow((double)10.0, (double)t2);
      }
      if (yAxisIsLog) {
	t3 = (float) pow((double)10.0, (double)t3);
	t4 = (float) pow((double)10.0, (double)t4);
      }
      [plotParam stackOldMinMax:t1 :t2 :t3 :t4];

      if (xAxisIsLog) {
	[plotParam resetXmin:pow((double)10.0, (double)(xmin/ppxunit))];
	[plotParam resetXmax:pow((double)10.0, (double)(xmax/ppxunit))];
      }
      else {
	[plotParam resetXmin:(double)(xmin/ppxunit)];
	[plotParam resetXmax:(double)(xmax/ppxunit)];
      }
      if (yAxisIsLog) {
	[plotParam resetYmin:pow((double)10.0, (double)(ymin/ppyunit))];
	[plotParam resetYmax:pow((double)10.0, (double)(ymax/ppyunit))];
      }
      else {
	[plotParam resetYmin:(double)(ymin/ppyunit)];
	[plotParam resetYmax:(double)(ymax/ppyunit)];
      }

      /*  Call [self display] to force current values of xmin/xmax/ymin/ymax
       *  to take effect (otherwise xmin, etc., get incremented too many times).
       */
      [self display];
    }
  }
  else if (zooming >= MOVELEGEND) {

    oldMask =  [window addToEventMask:NX_MOUSEDRAGGEDMASK];
    startPoint = e->location;
    [self convertPoint:&startPoint fromView:nil];
    if (zooming == MOVELEGEND) {
      NXSetRect(&bbox,startPoint.x,startPoint.y,
		legendbox.size.width,legendbox.size.height);
    }
    else if (zooming == MOVEXTITLE) {
      NXSetRect(&bbox,startPoint.x,startPoint.y,
		xtitlebox.size.width,xtitlebox.size.height);
    }
    else if (zooming == MOVEYTITLE) {
      NXSetRect(&bbox,startPoint.x,startPoint.y,
		ytitlebox.size.width,ytitlebox.size.height);
    }
    else if (zooming == MOVEMAINTITLE) {
      NXSetRect(&bbox,startPoint.x,startPoint.y,
		maintitlebox.size.width,maintitlebox.size.height);
    }
    [self lockFocus];
    while (looping) {
      e=[NXApp getNextEvent:NX_MOUSEUPMASK | NX_MOUSEDRAGGEDMASK];
      currPoint = e->location;
      [self convertPoint:&currPoint fromView:nil];
      bbox.origin.x = currPoint.x;
      bbox.origin.y = currPoint.y;
      PSnewinstance();
      if ((looping = (e->type == NX_MOUSEDRAGGED))) {
	PSsetinstance(YES);
	NXSetColor([plotParam provideTextColor]);
	NXFrameRect(&bbox);
	PSsetinstance(NO);
      }
    }
    [self unlockFocus];
    [window setEventMask:oldMask];
    /*
     * At this point, bbox is in window coordinates. 
     */
    if (zooming == MOVELEGEND) {
      legendbox.origin.x = bbox.origin.x;
      legendbox.origin.y = bbox.origin.y;
    }
    else if (zooming == MOVEXTITLE) {
      xtitlebox.origin.x = bbox.origin.x;
      xtitlebox.origin.y = bbox.origin.y;
    }
    else if (zooming == MOVEYTITLE) {
      ytitlebox.origin.x = bbox.origin.x;
      ytitlebox.origin.y = bbox.origin.y;
    }
    else if (zooming == MOVEMAINTITLE) {
      maintitlebox.origin.x = bbox.origin.x;
      maintitlebox.origin.y = bbox.origin.y;
    }

    /*  Call [self display] to give immediate feedback   */
    [self display];
  }

  return self;
}

- saveEPS:sender
{
  id savePanel = [[SavePanel new] setRequiredFileType:"eps"];
  char  *eps_fileName;	// Name of the EPS file for output

  [savePanel setTitle:"Save EPS"]; /* make sure title is OK */
  if ([savePanel runModal])  {
    eps_fileName = (char *) calloc(strlen([savePanel filename])+1, sizeof(char));
    strcpy(eps_fileName, [savePanel filename]);
    [self savePSCode:eps_fileName];
  }

  return self;
}

- savePSCode:(char *)aFile
{
    NXStream	*psStream;

    psStream = NXOpenMemory(NULL, 0, NX_WRITEONLY);
    if (!psStream)  {
      return self;
    }
    [self getBounds:&bounds];
    [self copyPSCodeInside:&bounds to:psStream];
	   
    NXFlush(psStream);
    NXSaveToFile(psStream, aFile);
    NXCloseMemory(psStream, NX_FREEBUFFER);

    return self;
}

/*
 * Following code taken from the Graph example in NextDeveloper/Examples.
 *
 * Copies the current view into the Pasteboard as PostScript.
 */
- copyPScode:sender
{
    NXStream *psStream;
    id        pb;
    char     *data;
    int       dataLen, maxDataLen;

  /* Open a stream on memory where we will collect the PostScript */
    psStream = NXOpenMemory(NULL, 0, NX_WRITEONLY);
    if (!psStream)
      return self;

  /* Tell the Pasteboard we're going to copy PostScript */
    pb = [Pasteboard new];
    [pb declareTypes:&NXPostScriptPboardType num:1 owner:self];

  /* writes the PostScript for the whole plot as EPS into the stream */
    [self getBounds:&bounds];
    [self copyPSCodeInside:&bounds to:psStream];

  /* get the buffered up PostScript out of the stream */
    NXGetMemoryBuffer(psStream, &data, &dataLen, &maxDataLen);

  /* put the buffer in the Pasteboard, free the stream (and the buffer) */
    [pb writeType:NXPostScriptPboardType data:data length:dataLen];
    NXCloseMemory(psStream, NX_FREEBUFFER);
    return self;
}

-setMainTitle:(char *)aString{
	if(mainTitle)NXZoneFree([self zone], mainTitle);
	mainTitle = NXCopyStringBufferFromZone(aString,[self zone]);		
	[self repositionTitles];
	return self;}
-setXAxisTitle:(char *)aString{
	if(xAxisTitle)NXZoneFree([self zone], xAxisTitle);
	xAxisTitle = NXCopyStringBufferFromZone(aString,[self zone]);		
	[self repositionTitles];
	return self;}
-setYAxisTitle:(char *)aString{
	if(yAxisTitle)NXZoneFree([self zone], yAxisTitle);
	yAxisTitle = NXCopyStringBufferFromZone(aString,[self zone]);		
	[self repositionTitles];
	return self;}
-setCurveTitle:(char *)aString{
	if(curveTitle)NXZoneFree([self zone], curveTitle);
	curveTitle = NXCopyStringBufferFromZone(aString,[self zone]);		
	[self repositionTitles];
	return self;}
-setLegendTitle:(char *)aString{
	if(legendTitle)NXZoneFree([self zone], legendTitle);
	legendTitle = NXCopyStringBufferFromZone(aString,[self zone]);		
	[self repositionTitles];
	return self;}
-(char *)mainTitle{return mainTitle;}
-(char *)xAxisTitle{return xAxisTitle;}
-(char *)yAxisTitle{return yAxisTitle;}

// For testing -- open data file via right mouse click...
- rightMouseDown:(NXEvent *)theEvent
{
// The following allows the uses to call up a file using the right mouse button when in
// the test mode of IB. My thanks to Alex Cone of OTI for tips used to write this.
// Note however that this will not work if there is a custom IB.
	if(strcmp([NXApp appName] , "InterfaceBuilder") ==0){
		[plotParam open:self];
		return self;
	}
	else{
		[self saveEPS:self];
		return self;
	}
}

 -setGrid:(int)grid_state{gridState=grid_state; return self;}
- setBorder:(int)border_state{ borderBox=border_state; return self;}
- setColorState:(int)color_state{colorState=color_state;return self;}
-(int)gridState{return gridState; }
-(int)borderState{ return borderBox;}
-(int)colorState{ return colorState;}

-setAutoMaxMinState:(int)state{autoMaxMinState=state; return self;}
-(int)autoMaxMinState{return autoMaxMinState;}

-setAutoPaperState:(int)state{
	autoPaperState=state;
	//[plotParam setXAxisToLog];
	//[plotParam setYAxisToLog];
	return self;
}
-(int)autoPaperState{return autoPaperState;}
-setXLinLogState:(int)state
{
	xLinLogState=state;
	if(state==NO)[plotParam setXAxisToLinear];
	else [plotParam setXAxisToLog];
	return self;
}
-(int)xLinLogState{return xLinLogState;}
-setYLinLogState:(int)state
{
	yLinLogState=state;
	if(state==NO)[plotParam setYAxisToLinear];
	else [plotParam setYAxisToLog];
	return self;
}
-(int)yLinLogState{return yLinLogState;}
-setPaperSwitchRow:(int)state{paperSwitchRow=state; return self;}
-(int)paperSwitchRow{return paperSwitchRow;}
-setLogoFlag:(int)state{logoFlag=state; return self;}
-(int)logoFlag{return logoFlag;}

- (void)setXIncValue:(float)passedValue{
	xIncValue = passedValue;
	[plotParam resetXinc:(double)passedValue];
}
- (void)setXMinValue:(float)passedValue{
	xMinValue = passedValue;
	[plotParam resetXmin:(double)passedValue];
}

- (void)setXMaxValue:(float)passedValue{
	xMaxValue = passedValue;
	[plotParam resetXmax:(double)passedValue];
}

- (void)setYIncValue:(float)passedValue{
	xIncValue = passedValue;
	[plotParam resetXinc:(double)passedValue];
}
- (void)setYMinValue:(float)passedValue{
	xMinValue = passedValue;
	[plotParam resetXmin:(double)passedValue];
}

- (void)setYMaxValue:(float)passedValue{
	xMaxValue = passedValue;
	[plotParam resetXmax:(double)passedValue];
}


-(float)xIncValue{return [plotParam provideXinc];}
-(float)xMinValue{return [plotParam provideXmin];}
-(float)xMaxValue{return [plotParam provideXmax];}
-(float)yIncValue{return [plotParam provideYinc];}
-(float)yMinValue{return [plotParam provideYmin];}
-(float)yMaxValue{return [plotParam provideYmax];}

- plotFromStream:(NXStream *)dataStream withDescription:(const char *)name
{
	[plotParam removeAllFiles:self];
	[plotParam readData:(NXStream *)dataStream :(const char *)name];
	[plotParam plotPrepAndDraw];
	return self;
}

- plotFromStream:(NXStream *)dataStream
{
	[plotParam removeAllFiles:self];
	[plotParam readData:dataStream :""];
	[plotParam plotPrepAndDraw];
	return self;
}

- sizeTo:(NXCoord)width :(NXCoord)height
// Allow resizing
{
	
	[super sizeTo:width :height];
	[self repositionTitles];

	return self;
}

- (void)repositionTitles
{
	float	width,height;

	legendbox.origin.x = bounds.size.width - 50.0; /* get the legendbox initialized here */
	legendbox.origin.y = bounds.size.height - 50.0;
	
	if(xAxisTitle){
		width = [xTitleFont getWidthOf:xAxisTitle];
		height = [xTitleFont pointSize];

		xtitlebox.origin.x = XOFFSET/4.0
						+ (bounds.size.width - width) /2.0;
		xtitlebox.origin.y = bounds.origin.y + YOFFSET/4.0;
		xtitlebox.size.width  = width;
		xtitlebox.size.height = height;
	}
		
	if(yAxisTitle){
		width = [yTitleFont getWidthOf:yAxisTitle];
		height = [yTitleFont pointSize];

		ytitlebox.origin.x = (bounds.origin.x + height/2) + XOFFSET/4.0;
		ytitlebox.origin.y = YOFFSET/4.0
							+ (bounds.size.height - width) /2.0;
		ytitlebox.size.width  = width;
		ytitlebox.size.height = height;
	}
	
	if(mainTitle){
		width = [mainTitleFont getWidthOf:mainTitle];
		height = [mainTitleFont pointSize];

		maintitlebox.origin.x = (bounds.size.width - width)/2.0;
		maintitlebox.origin.y = (bounds.size.height- height/2) - YOFFSET/4.0;
		maintitlebox.size.width  = width;
		maintitlebox.size.height = height;
	}

}

- (BOOL) acceptsFirstMouse { return YES;}      /* grab that mouse down event! */

- mainTitleFont   { return mainTitleFont;}
- xTitleFont      { return xTitleFont;}
- yTitleFont      { return yTitleFont;}
- legendTitleFont { return legendTitleFont;}
- legendFont      { return legendFont;}
- ticLabelFont    { return ticLabelFont;}
- (NXPoint) legendBoxOrigin { return legendbox.origin;}
- (NXPoint) xTitleBoxOrigin { return xtitlebox.origin;}
- (NXPoint) yTitleBoxOrigin { return ytitlebox.origin;}
- (NXPoint) mainTitleBoxOrigin { return maintitlebox.origin;}

/* All these method names start with "set" */

- setLegendBoxOrigin: (NXPoint)point
{
  legendbox.origin = point;
  return self;
}

- setXTitleBoxOrigin: (NXPoint)point
{
  xtitlebox.origin = point;
  return self;
}

- setYTitleBoxOrigin: (NXPoint)point
{
  ytitlebox.origin = point;
  return self;
}

- setMainTitleBoxOrigin: (NXPoint)point
{
  maintitlebox.origin = point;
  return self;
}

- setMainTitleFont:aFont
{
	mainTitleFont = aFont;
	[self repositionTitles];
	return self;
}

- setXTitleFont:aFont
{
	xTitleFont = aFont;
	[self repositionTitles];
	return self;
}

- setYTitleFont:aFont;
{
	yTitleFont = aFont;
	[self repositionTitles];
	return self;
}

- setLegendFont:aFont
{
	legendFont = aFont;
	[self repositionTitles];
	return self;
}

- setLegendTitleFont:aFont
{
	legendTitleFont = aFont;
	[self repositionTitles];
	return self;
}

- setTicLabelFont:aFont
{
	ticLabelFont = aFont;
	[self repositionTitles];
	return self;
}

- (const char *) getInspectorClassName
{
     return "XYPlotInspector";
}

- awake
{
	plotParam = [[XYPlot allocFromZone:[self zone]] initWithCanvas:self];

	if(!theFontManager) theFontManager = [FontManager new];

	[plotParam colorOn:colorState];
 
	[self setXLinLogState:xLinLogState];
	[self setYLinLogState:yLinLogState];
	[self setAutoPaperState:autoPaperState];
 

	gridThickness = 0.0;
	axisThickness = 0.0;
	legend = NO;
	majorTicMarks = YES;
	minorTicMarks = YES;
	opaqueBackground = NO;
	errorBarBaseWidth = 3.0;
	handFormatXaxis = NO;
	handFormatYaxis = NO;
  
	frameBox = YES;

	[self repositionTitles];

	return self;
}

- write:(NXTypedStream *)typedStream
{
	[super write:typedStream];
		
	NXWriteTypes(typedStream,"iiii",&borderBox,&gridState,&autoMaxMinState,&autoPaperState);
	NXWriteTypes(typedStream,"iiiii",&logoFlag,&paperSwitchRow,&colorState,&xLinLogState,&yLinLogState);

	NXWriteTypes(typedStream,"ffff",&borderBoxThickness,&lineThickness,&ppxunit,&ppyunit);

	NXWriteTypes(typedStream,"fff",&xIncValue,&xMinValue,&xMaxValue);
	NXWriteTypes(typedStream,"fff",&yIncValue,&yMinValue,&yMaxValue);

	NXWriteTypes(typedStream,"*****",&xAxisTitle,&yAxisTitle,&mainTitle,&curveTitle,&legendTitle);

	NXWriteTypes(typedStream,"@@@",&xTitleFont,&yTitleFont,&mainTitleFont);
	NXWriteTypes(typedStream,"@@@",&legendFont,&legendTitleFont,&ticLabelFont);

	return self;
}

- read:(NXTypedStream *)typedStream
{
	[super read:typedStream];
	
	NXReadTypes(typedStream,"iiii",&borderBox,&gridState,&autoMaxMinState,&autoPaperState);
	NXReadTypes(typedStream,"iiiii",&logoFlag,&paperSwitchRow,&colorState,&xLinLogState,&yLinLogState);
	
	NXReadTypes(typedStream,"ffff",&borderBoxThickness,&lineThickness,&ppxunit,&ppyunit);

	NXReadTypes(typedStream,"fff",&xIncValue,&xMinValue,&xMaxValue);
	NXReadTypes(typedStream,"fff",&yIncValue,&yMinValue,&yMaxValue);
	
	NXReadTypes(typedStream,"*****",&xAxisTitle,&yAxisTitle,&mainTitle,&curveTitle,&legendTitle);	
	
	NXReadTypes(typedStream,"@@@",&xTitleFont,&yTitleFont,&mainTitleFont);
	NXReadTypes(typedStream,"@@@",&legendFont,&legendTitleFont,&ticLabelFont);
	
	xIncValue = 0.0;
	xMinValue = 0.0;
	xMaxValue = 0.0;
	yIncValue = 0.0;
	yMinValue = 0.0;
	yMaxValue = 0.0;
	
	logoFlag = NO;
	
	return self;
}


@end
